#include <main.h>


static uint8_t triggerz;
static uint8_t tx1sendezel=0;  // Zhlvariable fr Putchar - fr Hardware-Buffer
static uint8_t triggergr;			   // Zhlvariable fr IRQ-Empfang Trigger-Bytes

// USART0 Receiver buffer
uint8_t rx_buffer1;
uint8_t rx_counter1=0;

// This flag is set on USART0 Receiver buffer overflow
uint8_t rx_buffer_overflow1=0;
uint8_t rx_error1=0;
uint8_t rx_reset1;
uint8_t trigger_timeout1=0;

void uart1_init(void)
{
    /* initialize the serial interface   */
  PINSEL0 = PINSEL0|0x00050000;           // Enable RxD1 and TxD1                     
  U1LCR = 0x83;                   // 8 bits, no Parity, 1 Stop bit            
  U1DLL = 0x21;                          // 115200 Baud Rate @ 60MHz VPB Clock  
  U1LCR = 0x03;                   // DLAB = 0                                 
  U1IER= 0x03;					  // Alle IRQ-S ein (auer Modem)

  //uart1_set(0);

  //U1FCR = 0x07;
  U1FCR = 0x00;
  rx_reset1=0x03;
  triggergr=1;

  VICVectAddr2 = (uint32_t)usart1_irq;          // set interrupt vector in 0
  VICVectCntl2 = 0x20 | 7;   // Vic UART1
  VICIntEnable = 0x0000080;                  // Enable Uart1 Interrupt
  //uart1_set(0);
  wait_ms(10);
}

int32_t getchar1(void)
{
uint8_t data;

while (rx_counter1==0);			// Wenn Soft-Buffer leer, dann warten bis Zeichen eingetroffen.
VICIntEnClr=0xFFFFFFFF;
data=rx_buffer1;
rx_counter1=0;
VICIntEnable=0xFFFFFFFF;
return data;
}

int32_t putchar(int32_t c)
{
while (tx1sendezel!=0);

VICIntEnClr=0xFFFFFFFF;
tx1sendezel++;							 // Wenn weniger als 16 Zeichen im Hard-Buffer sind,
//tx1sendezel=1;
U1THR=c;								 // Kann sofort ein Zeichen in das Register geschoben										 // werden.
VICIntEnable=0xFFFFFFFF;				 // IRQ-Einschalten
return(c);
}


// USART1 IRQ-Routine
void usart1_irq(void) __irq
{
uint8_t status;

status=U1IIR&0x0F;		        // Statusregister abfragen.
								// Sende-IRQ wird jetzt gelscht.
switch(status)
{
case 0x04:  // Empfangen	   // Hardware-Buffer wird entleert und in den Soft-Buffer geschoben.
      rx_buffer1=U1RBR;
	  rx_counter1=1;
break;
  
case 0x02: // Senden

 tx1sendezel=0; // Kein Zeichen befindet sich mehr im Hard-Buffer. - Zhler auf 0.

break;
}
VICVectAddr = 0; // Acknowledge Interrupt
}
